;OBJ

.model large

BIOSData     segment at 0040h

             org 006Ch

Timer        label dword
TimerLow      dw    ?
TimerHigh     dw    ?

BIOSData     ends

.data

             extrn PCXData : byte

.code

RGB          struc
red           db    ?
green         db    ?
blue          db    ?
RGB          ends

PCXHeader    struc
 PCXH_ID      db    ?                  ; Identifikation des Herstellers (10)
 PCXH_Ver     db    ?                  ; Versionsnummer:
                                       ;  2 - altes PCX ohne Palette
                                       ;  3 - ohne Palette
                                       ;  4 - Windows 2.x ohne Palette
                                       ;  5 - mit Palette
 PCXH_Encod   db    ?                  ; Kodierung  (1)
 PCXH_BPB     db    ?                  ; Bit pro Pixel und Plane (1,2,4 oder 8)
 PCXH_xmin    dw    ?                  ; Eckkordinaten
 PCXH_ymin    dw    ?
 PCXH_xmax    dw    ?
 PCXH_ymax    dw    ?
 PCXH_xdpi    dw    ?                  ; Auflsung
 PCXH_ydpi    dw    ?
 PCXH_pal_0   RGB   <>                 ; 16 mal RGB  256 Werte pro Byte (frei)
 PCXH_pal_1   RGB   <>
 PCXH_pal_2   RGB   <>
 PCXH_pal_3   RGB   <>
 PCXH_pal_4   RGB   <>
 PCXH_pal_5   RGB   <>
 PCXH_pal_6   RGB   <>
 PCXH_pal_7   RGB   <>
 PCXH_pal_8   RGB   <>
 PCXH_pal_9   RGB   <>
 PCXH_pal_10  RGB   <>
 PCXH_pal_11  RGB   <>
 PCXH_pal_12  RGB   <>
 PCXH_pal_13  RGB   <>
 PCXH_pal_14  RGB   <>
 PCXH_pal_15  RGB   <>
              db    ?                  ; reserviert
 PCXH_planes  db    ?                  ; Anzahl Farbebenen (1)
 PCXH_BPL     dw    ?                  ; Byte pro Zeile und Plane, mu GERADE sein
 PCXH_PalInfo dw    ?                  ; Palettentyp: 1 = s/w oder Farbe
                                       ;              2 = Graustufen (PC Paintbrush ab IV)
              db    58 dup (?)         ; reserviert
 PCXH_ImageData db  ?
PCXHeader    ends

INITREQUEST STRUC   ; Parameterblock fr INIT
 irLength        db ?    ; Gesamtumfang des Parameterblocks
 irUnit          db ?    ; nicht verwendet
 irFunction      db ?    ; Funktion $00, d.h. Init
 irStatus        dw ?    ; Ergebniscode der Initialisierung
 irReserved      db 8 dup (?) ; "reserviert", nicht verwendet
 irUnits         db ?    ; Zahl der vom Treiber bedienten Gerte
 irEndAddress    dd ?    ; hchste verfgbare/belegte Speicheradresse
 irParamAddress  dd ?    ; Adresse der Kommandozeile (device=...)
 irDriveNumber   db ?    ; erste nicht belegte Laufwerks-Kennz.
 irMessageFlag   db ?    ; Flag fr Fehlermeldungen
INITREQUEST ENDS

             assume ds : nothing, es : nothing, ss : nothing

DNext         dd    -1
DAttr         dw    8000h
DStrat        dw    offset Strat
DIntr         dw    offset Intr
DName         db    '***IMAGE.ASM  Version 1.00  (C) 1997 Alexander Foken***'

Strat        proc far
              mov   cs:SaveES,es
              mov   cs:SaveBX,bx
              ret
Strat        endp

Intr         proc far
              pushf
              push  ax
              push  bx
              push  cx
              push  dx
              push  si
              push  di
              push  ds
              push  es

              mov   bx,0F000h
 SaveES      equ word ptr $-2
              mov   es,bx
              mov   bx,0000h
 SaveBX      equ word ptr $-2
              mov   word ptr es:[bx+2].InitRequest.irEndAddress,cs
              xor   ax,ax
              mov   word ptr es:[bx].InitRequest.irEndAddress,ax
              inc   ah
              mov   es:[bx].InitRequest.irStatus,ax

              lds   si,es:[bx].InitRequest.irParamAddress
              call  GetTime

              call  ShowImage

              pop   es
              pop   ds
              pop   di
              pop   si
              pop   dx
              pop   cx
              pop   bx
              pop   ax
              popf
              ret
Intr         endp

Delay         dw    0

ShowImage    proc near
              mov   si,seg PCXData
              mov   ds,si
              mov   si,offset PCXData+offset PCXH_ImageData

              mov   di,0A000h
              mov   es,di
              xor   di,di

              mov   ax,13h
              int   10h

              cld

 @@Loop:      cmp   di,320*200
              ja    @@Pal

              lodsb
              cmp   al,0C0h
              ja    @@Multi
              je    @@Special
              stosb
              jmp   short @@Loop

 @@Special:   lodsb
              stosb
              jmp   short @@Loop

 @@Multi:     mov   cl,al
              and   cx,003Fh
              lodsb
              rep   stosb
              jmp   short @@Loop

 @@Pal:       mov   dx,3C8h
              xor   cx,cx             ; Farbe

 @@PalLoop:   mov   al,cl
              out   dx,al
              inc   dx
              lodsb                   ; ROT
              shr   al,1
              shr   al,1
              out   dx,al
              lodsb                   ; GRN
              shr   al,1
              shr   al,1
              out   dx,al
              lodsb                   ; BLAU
              shr   al,1
              shr   al,1
              out   dx,al
              dec   dx

              inc   cx
              cmp   cx,256
              jb    @@PalLoop

              mov   ax,0040h
              mov   ds,ax

             assume ds : BIOSData

              mov   cx,Delay
              jcxz  @@Key

              add   cx,TimerLow

 @@TimeLoop:  mov   ah,1
              int   16h
              jnz   @@Key
              cmp   cx,TimerLow
              jae   @@TimeLoop
              jmp   short @@raus

 @@Key:       xor   ax,ax
              int   16h

 @@raus:      mov   ax,3
              int   10h

              ret
ShowImage    endp


GetTime      proc near
              cld

 @@NextChar:  lodsb
              or    al,al
              jz    @@ende
              cmp   al,13
              je    @@ende
              cmp   al,10
              je    @@ende

              cmp   al,'/'
              jne   @@NextChar

 @@NextDigit: lodsb
              sub   al,'0'
              js    @@ende
              cmp   al,9
              ja    @@ende
              xor   ah,ah
              mov   bx,ax
              mov   al,10
              mul   Delay
              add   ax,bx
              mov   Delay,ax
              jmp   short @@NextDigit

 @@ende:      ret
GetTime      endp


Main         proc near
              mov   si,0081h
              call  GetTime

              call  ShowImage
              mov   ax,4C00h
              int   21h
Main         endp

.stack 2048

             end Main